searchNodes=[{"doc":"Play music in Elixir!","ref":"MIDISynth.html","title":"MIDISynth","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"MIDISynth.html#child_spec/1","title":"MIDISynth.child_spec/1","type":"function"},{"doc":"Send a raw MIDI command to the synthesizer See MIDISynth.Command for encoding MIDI commands and MIDISynth.Keyboard for playing simple songs. Examples iex&gt; {:ok, synth} = MIDISynth.start_link([]) iex&gt; MIDISynth.midi(synth, &lt;&lt;0x90, 60, 127&gt;&gt;) :ok","ref":"MIDISynth.html#midi/2","title":"MIDISynth.midi/2","type":"function"},{"doc":"Start a MIDI synthesizer Synthesizer arguments: :soundfont - the path to the sound font to use for synthesize. Uses FluidR2_GM.sf2 by default.","ref":"MIDISynth.html#start_link/2","title":"MIDISynth.start_link/2","type":"function"},{"doc":"Convert MIDI commands to raw bytes","ref":"MIDISynth.Command.html","title":"MIDISynth.Command","type":"module"},{"doc":"Change the MIDI controller value of a channel.","ref":"MIDISynth.Command.html#change_control/3","title":"MIDISynth.Command.change_control/3","type":"function"},{"doc":"Change the current program (e.g. instrument) of a channel.","ref":"MIDISynth.Command.html#change_program/2","title":"MIDISynth.Command.change_program/2","type":"function"},{"doc":"Change the sound bank of a channel.","ref":"MIDISynth.Command.html#change_sound_bank/2","title":"MIDISynth.Command.change_sound_bank/2","type":"function"},{"doc":"Change the volume of a MIDI channel. This change is applied to all playing and future notes.","ref":"MIDISynth.Command.html#change_volume/2","title":"MIDISynth.Command.change_volume/2","type":"function"},{"doc":"Turn a note in a channel off.","ref":"MIDISynth.Command.html#note_off/2","title":"MIDISynth.Command.note_off/2","type":"function"},{"doc":"Turn all active notes in a channel off.","ref":"MIDISynth.Command.html#note_off_all/1","title":"MIDISynth.Command.note_off_all/1","type":"function"},{"doc":"Turn a note in a channel on.","ref":"MIDISynth.Command.html#note_on/3","title":"MIDISynth.Command.note_on/3","type":"function"},{"doc":"Change the panoramic (pan) of a channel. This shifts the sound from the left or right ear in when playing stereo. Values below 64 moves the sound to the left, and above to the right.","ref":"MIDISynth.Command.html#pan/2","title":"MIDISynth.Command.pan/2","type":"function"},{"doc":"Bend the pitch of notes playing in a channel. Values below 0x2000 will decrease the pitch, and higher values will increase it.","ref":"MIDISynth.Command.html#pitch_bend/2","title":"MIDISynth.Command.pitch_bend/2","type":"function"},{"doc":"A MIDI channel number","ref":"MIDISynth.Command.html#t:channel/0","title":"MIDISynth.Command.channel/0","type":"type"},{"doc":"The duration in milliseconds for which to hold down a note.","ref":"MIDISynth.Command.html#t:duration/0","title":"MIDISynth.Command.duration/0","type":"type"},{"doc":"A 7-bit integer","ref":"MIDISynth.Command.html#t:int7/0","title":"MIDISynth.Command.int7/0","type":"type"},{"doc":"A MIDI note For non-percussion instruments, the frequency of a note is 440 * 2^((n − 69) / 12) where n is the note number. Middle C is 60","ref":"MIDISynth.Command.html#t:note/0","title":"MIDISynth.Command.note/0","type":"type"},{"doc":"A MIDI program","ref":"MIDISynth.Command.html#t:program/0","title":"MIDISynth.Command.program/0","type":"type"},{"doc":"The velocity to strike the note. 127 = maximum velocity","ref":"MIDISynth.Command.html#t:velocity/0","title":"MIDISynth.Command.velocity/0","type":"type"},{"doc":"A channel volume","ref":"MIDISynth.Command.html#t:volume/0","title":"MIDISynth.Command.volume/0","type":"type"},{"doc":"Simple keyboard functions for sending MIDI commands to the synthesizer","ref":"MIDISynth.Keyboard.html","title":"MIDISynth.Keyboard","type":"module"},{"doc":"Change the current program (e.g., the current instrument) The soundfont that's supplied to MIDISynth.start_link/2 determines the mapping from program numbers to instruments. The default is to use a general MIDI soundfont, and instrument mappings for those can be found by looking at the General MIDI 1 and General MIDI 2 specifications. Example # Play a violin iex&gt; {:ok, synth} = MIDISynth.start_link([]) iex&gt; MIDISynth.Keyboard.change_program(synth, 41) :ok iex&gt; MIDISynth.Keyboard.play(synth, 60, 100) :ok","ref":"MIDISynth.Keyboard.html#change_program/3","title":"MIDISynth.Keyboard.change_program/3","type":"function"},{"doc":"Play a note This is a utility method for pressing a note down and then releasing it after a duration. Example iex&gt; {:ok, synth} = MIDISynth.start_link([]) iex&gt; MIDISynth.Keyboard.play(synth, 60, 100) :ok iex&gt; MIDISynth.Keyboard.play(synth, 60, 100, 80) :ok","ref":"MIDISynth.Keyboard.html#play/5","title":"MIDISynth.Keyboard.play/5","type":"function"},{"doc":"MIDISynth Play music in Elixir.","ref":"readme.html","title":"MIDISynth","type":"extras"},{"doc":"First, install FluidSynth . On Linux: sudo apt install libfluidsynth-dev On OSX: brew install fluidsynth Next, either clone this library or pull it in as a dependency to your Elixir project. The following is an example of the dependency for your mix.exs : { :midi_synth , &quot;~&gt; 0.4.0&quot; } Fetch dependencies and build as you normally would. The first build will download the FluidR3_GM.sf2 soundfont file. This is a Creative Commons-licensed data file that contains all of the General MIDI instruments. It is a good place to start, but can be changed later on.","ref":"readme.html#trying-it-out","title":"MIDISynth - Trying it out","type":"extras"},{"doc":"Start IEx by running iex -S mix from a shell prompt. MIDISynth is a GenServer and must be started first. The library comes with with helpers to make playing simple things easy. For more complicated uses, you'll want to build on this library. OK, let's play a note. Notes are numbered sequentially. Middle C is note 60. Here's how to play middle C for 100 ms. iex&gt; { :ok , synth } = MIDISynth . start_link ( [ ] ) { :ok , # PID &lt; 0 . 226 . 0 &gt; } iex&gt; MIDISynth.Keyboard . play ( synth , 60 , 100 ) You can play the same note with a different velocity. The velocities range from 1 to 127. Here's how to play middle C for 100 ms with velocity mezzo-forte: 80. iex&gt; MIDISynth.Keyboard . play ( synth , 60 , 100 , 80 ) If you don't like the piano, try switching the instrument to something else. For example, trumpets (General MIDI instrument 57) are nice: iex&gt; MIDISynth.Keyboard . change_program ( synth , 57 ) iex&gt; MIDISynth.Keyboard . play ( synth , 60 , 500 ) Percussion instruments can be played only through MIDI channel 9. For example, this is how to play a cowbell sound: iex&gt; MIDISynth.Keyboard . play ( synth , 56 , 0 , 127 , 9 ) The real value of this library is the ability to send raw MIDI messages to the FluidSynth library. The Elixir code barely scratches the surface of what's possible. If you're comfortable with raw MIDI commands , try this out: iex&gt; MIDISynth . midi ( synth , &lt;&lt; 0x90 , 60 , 127 &gt;&gt; ) iex&gt; MIDISynth . midi ( synth , &lt;&lt; 0x80 , 60 , 127 &gt;&gt; ) See MIDISynth.Command for help with encoding messages, and please feel free to add more.","ref":"readme.html#try-it-out-using-iex","title":"MIDISynth - Try it out using IEx","type":"extras"},{"doc":"The Elixir and C code are covered by the Apache 2 License.","ref":"readme.html#license","title":"MIDISynth - License","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Bug fixes Fix compilation issues on OSX and make OSX default audio device portaudio . The coreaudio default isn't working and Homebrew installs portaudio with fluidsynth.","ref":"changelog.html#0-4-1","title":"Changelog - 0.4.1","type":"extras"},{"doc":"New features Support specification of MIDI channels in MIDISynth.Command . This is a backwards incompatible API change if you're using MIDISynth.Command . The previous code hardcoded the channel to 0 . Several new commands were added to MIDISynth.Command . Thanks to Pim Kunis for these updates!","ref":"changelog.html#0-4-0","title":"Changelog - 0.4.0","type":"extras"},{"doc":"This release updates the Elixir and make code to fix many issues. The library is the functionally the same as before, but every API call has changed. The biggest changes are that the main module was renamed to MIDISynth and it's now a GenServer that should be manually started or added to a supervision tree of your choosing. MIDI command encoders are now located in MIDISynth.Command . Please send PRs back for any other commands you may want to use. MIDISynth.Keyboard provides a functions for playing back simple songs. MIDISynth forwards raw MIDI commands to libfluidsynth , so it offers a lot of functionality. The hope is that other libraries build on this and provide the sequencers and higher level APIs to make complex music generation possible. Enjoy!","ref":"changelog.html#0-3-0","title":"Changelog - 0.3.0","type":"extras"},{"doc":"New features Note velocity is supported. Unspecified velocities default to 127.","ref":"changelog.html#0-2-0","title":"Changelog - 0.2.0","type":"extras"},{"doc":"Initial release","ref":"changelog.html#0-1-0","title":"Changelog - 0.1.0","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright [yyyy] [name of copyright owner] Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]